SystemOrganization addCategory: #reunidosTADP!
SystemOrganization addCategory: #'reunidosTADP-Tests'!

Trait named: #CosteablePorHora
	uses: {}
	category: 'reunidosTADP'!

!CosteablePorHora methodsFor: 'as yet unclassified' stamp: 'Paul 4/17/2012 16:29'!
costoPara: unaReunion
	"calcula el costo para una reunion en base de la duracion de la reunion y el costo por hora"

	^ unaReunion duracion * self costoPorHora! !

!CosteablePorHora methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/18/2012 12:04'!
costoPorHora 
"requerido"! !

Trait named: #Horario
	uses: {}
	category: 'reunidosTADP'!

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:02'!
horariosDisponibles
  | unosRangos rangoLibreUno rangoLibreDos |

unosRangos := Set new.
rangoLibreUno:= Rango rangoUniversal..

self horariosOcupados do:
		[ :rangoOcupado |
			rangoLibreDos := rangoLibreUno substract: rangoOcupado.
			unosRangos add: rangoLibreUno.
			rangoLibreUno := rangoLibreDos. ].
		unosRangos add: rangoLibreDos.
^ unosRangos . ! !

!Horario methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/20/2012 15:01'!
horariosOcupados
 "forma parte del contrato de uso del Trait, es un accesor de las instancias de los objetos que usan Horario"! !

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:03'!
ocupateDurante: unRango
	self horariosOcupados add: unRango.! !

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 15:03'!
tenesDisponible: unRango

	^self horariosOcupados allSatisfy: [:rango | (rango overlaps: unRango) not]! !

!Horario methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 13:16'!
tenesDuracionDisponible: unaDuracion

^ self horariosDisponibles anySatisfy:  [:unRango | unRango size >= unaDuracion] .! !

TestCase subclass: #TestCriterioMultiple
	instanceVariableNames: 'persona criterio persona2 persona3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestCriterioMultiple methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:17'!
setUp
|association1 association2|
persona:= Persona nuevaAsignadaA: 'ace' conRol: 'programador'  enUnEdificio:  'Alem' sector: 'IT'.
persona2:= Persona nuevaAsignadaA: 'ace' conRol: 'diseadorDeSistemas'  enUnEdificio: 'Catalinas' sector: 'IT'.
persona3:= Persona nuevaAsignadaA: 'notes' conRol:'PM'  enUnEdificio: 'Martinez' sector: 'Management'.
criterio:= CriterioMultiple new criterios: Dictionary new; personasConvocables: Set new.
"association1:= Association key: 'rol' value: 'Developer'.
association2:= Association key: 'proyecto' value:'ace'. 
criterio criterios add: association1.
criterio criterios add: association2."
criterio criterios at: 'rol' put: 'programador'; at: 'proyecto' put: 'ace'.
criterio personasConvocables add: persona; add: persona2; add: persona3.! !

!TestCriterioMultiple methodsFor: 'tests' stamp: 'ClaraAllende 4/20/2012 09:55'!
testPersonaCumpleTodosLosCriterios

criterio filtra: criterio personasConvocables .
"self assert: persona proyecto equals: (criterio criterios at: 'proyecto').
self assert: persona rol equals: (criterio criterios at: 'rol')."

self assert: (criterio personasConvocables includes: persona)! !

TestCase subclass: #TestCriterioSimple
	instanceVariableNames: 'persona criterio persona2 persona3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestCriterioSimple methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:10'!
setUp

persona:= Persona nuevaAsignadaA: 'ace' conRol: 'programador' enUnEdificio:'huergo2' sector: 'IT'.
persona2:= Persona nuevaAsignadaA: 'ace' conRol:'PM'  enUnEdificio:'Alem' sector: 'management'.
persona3:=  Persona nuevaAsignadaA: 'notes' conRol:'programador'  enUnEdificio: 'Martinez' sector: 'IT'. 
criterio:= CriterioUnico new condicion: 'proyecto'; parametro: 'ace'; personasConvocables: Set new.
criterio personasConvocables add: persona; add: persona2 ; add:persona3.! !

!TestCriterioSimple methodsFor: 'tests' stamp: 'ClaraAllende 4/19/2012 13:25'!
testPersonaCumpleCriterio
 
criterio filtra: criterio personasConvocables.
self assert: (criterio personasConvocables includes: persona).
self assert: persona proyecto equals: criterio parametro.! !

TestCase subclass: #TestHorarioDisponible
	instanceVariableNames: 'persona horarioOcupado rangoUno rangoDos coleccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestHorarioDisponible methodsFor: 'running' stamp: 'LucasGiudice 4/20/2012 15:02'!
setUp 
|inicioRango1 finRango1 inicioRango2 finRango2 rangoCuatro rangoTres |

inicioRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 19  minute: 15.
finRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 22  minute: 15.

rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

persona:= Persona new.
persona horariosOcupados add: rangoUno.

inicioRango2 := DateAndTime today. 
finRango2 := DateAndTime tomorrow.

rangoDos:= Rango new.
rangoDos start: inicioRango2; end: finRango2.
 
rangoTres:= Rango new.

rangoTres start: DateAndTime today; end: rangoUno start.

rangoCuatro:= rangoUno startingOn: rangoUno end.

coleccion := Set with: rangoTres with: rangoCuatro.! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:29'!
testPersonaHorariosDisponiblesRango
	"Verifica que todos los elementos de los horariosDisponibles esten contenidos en la coleccion que viene del #setUp y viceversa"

	| disponibles bol |
	disponibles := persona horariosDisponibles.
	self
		assert:
			(disponibles
				anySatisfy: [ :rangoDisponible | coleccion anySatisfy: [ :rangoPrueba | rangoPrueba equals: rangoDisponible ] ]).
	self
		assert:
			(coleccion
				anySatisfy: [ :rangoPrueba | disponibles anySatisfy: [ :rangoDisponible | rangoPrueba equals: rangoDisponible ] ])! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:38'!
testPersonaTenesDisponibleRango
	self assert: (persona tenesDisponible: rangoDos)! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:38'!
testPersonaTenesDuracionDisponible
	self assert: (persona tenesDuracionDisponible: rangoUno size).
	self assert: (persona tenesDuracionDisponible: rangoDos size)! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:40'!
testPersonaTenesDuracionDisponibleFalse
	"Si tiene al menos un horarioOcupado, la unica duracion que no tiene disponible es aquella que abarca desde hoy hasta el dia final"

	self assert: persona horariosOcupados notEmpty.
	self deny: (persona tenesDuracionDisponible: Rango rangoUniversal size)! !

TestCase subclass: #TestRequerimiento
	instanceVariableNames: 'criterio1 unRequerimiento criterio2 persona1 persona2 persona3 set1 set2 set3 persona4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

TestRequerimiento class
	instanceVariableNames: 'set2 persona1 persona2 persona3'!

TestRequerimiento class
	instanceVariableNames: 'set2 persona1 persona2 persona3'!

!TestRequerimiento methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:03'!
setUp

criterio1:= CriterioUnico nuevoConCondicion: 'rol' yParametro: 'PM'.
criterio2:= CriterioMultiple nuevoConCondiciones: (#('rol' 'proyecto' 'nombre')) parametros: (#('programador' 'ace' 'Clari')).
persona1:= Persona nuevaAsignadaA: 'ace' conRol:'programador'  enUnEdificio: 'Catalinas' sector: 'IT'. 
persona1 nombre: 'Clari'.
persona2:= Persona nuevaAsignadaA: 'notes' conRol: 'PM'  enUnEdificio: 'Huergo1'sector: 'management'. 
persona3:= Persona nuevaAsignadaA: 'costSuite' conRol: 'diseadorGrafico' enUnEdificio: 'Alem' sector:'IT'.
persona4:= Persona nuevaAsignadaA: 'estimatedCost' conRol: 'diseadorDeSIstemas' enUnEdificio: 'Martinez' sector:'IT'. 
unRequerimiento:= Requerimiento new requerimientosDeTurno:  (Set with: criterio1 with: criterio2).
unRequerimiento personas: Set new.

set1:= Set with: persona1 with: persona2.
set2:= Set with: persona1 with: persona2 with: persona3.
set3:= Set with: persona3 with: persona4.! !

!TestRequerimiento methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:37'!
testPersonasCumplenRequerimiento
	"va a seguir fallando hast que se inicialize la reunion, ahora dice que en el metodo posiblesAsistentesConDisponibilidadHoraria nil esta recibiendo el mje duracion."

	unRequerimiento personas: set1.
	unRequerimiento seleccionarAsistentes.
	self
		assert: (unRequerimiento convocados includesAllOf: set1)
		description: 'Existen personas que satisfacen el requerimiento'! !

!TestRequerimiento methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:37'!
testPersonasNoCumplenRequerimiento
	unRequerimiento personas: set3.
	unRequerimiento seleccionarAsistentes.
	self
		deny: (unRequerimiento convocados includesAllOf: set3)
		description: 'No hay ninguna persona que cumpla el requerimiento'! !

TestCase subclass: #TestReunion
	instanceVariableNames: 'ibm theHost criterio1 criterio2 persona1 persona2 persona3 persona4 unRequerimiento set1 set2 set3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestReunion methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:36'!
setUp

ibm:= Empresa new.
theHost:= Persona nuevaAsignadaA: 'ace' conRol:'PM'  enUnEdificio: 'Catalinas' sector: 'management'.
criterio1:= CriterioUnico nuevoConCondicion: 'rol' yParametro: 'PM'.
criterio2:= CriterioMultiple nuevoConCondiciones: (#('rol' 'proyecto' 'nombre')) parametros: (#('programador' 'ace' 'Clari')).
persona1:= Persona nuevaAsignadaA: 'ace' conRol:'programador'  enUnEdificio: 'Catalinas' sector: 'IT'. 
persona1 nombre: 'Clari'.
persona2:= Persona nuevaAsignadaA: 'notes' conRol: 'PM'  enUnEdificio: 'Huergo1'sector: 'management'. 
persona3:= Persona nuevaAsignadaA: 'costSuite' conRol: 'diseadorGrafico' enUnEdificio: 'Alem' sector:'IT'.
persona4:= Persona nuevaAsignadaA: 'estimatedCost' conRol: 'diseadorDeSistemas' enUnEdificio: 'Martinez' sector:'IT'. 
unRequerimiento:= Requerimiento new requerimientosDeTurno:  (Set with: criterio1 with: criterio2).

set1:= Set with: persona1 with: persona2.
set2:= Set with: persona1 with: persona2 with: persona3.
set3:= Set with: persona3 with: persona4.! !

!TestReunion methodsFor: 'tests' stamp: 'ClaraAllende 4/20/2012 17:13'!
testSePuedeRealizarReunion

"TODO"

! !

Object subclass: #Catering
	uses: Horario + CosteablePorHora
	instanceVariableNames: 'horariosOcupados costo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Catering class
	uses: Horario classTrait + CosteablePorHora classTrait
	instanceVariableNames: ''!

!Catering methodsFor: 'accessing' stamp: 'LucasGiudice 4/18/2012 12:06'!
costoPorHora 
^costo! !

!Catering methodsFor: 'accessing' stamp: 'LucasGiudice 4/20/2012 14:59'!
horariosOcupados
	^horariosOcupados ! !

!Catering methodsFor: 'initialization' stamp: 'LucasGiudice 4/18/2012 12:05'!
initialize 
horarioOcupado := Set new.! !

Object subclass: #CriterioMultiple
	instanceVariableNames: 'criterios personasConvocables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!CriterioMultiple class methodsFor: 'instance creation' stamp: 'ClaraAllende 4/20/2012 09:08'!
nuevoConCondiciones: anArray parametros: anArray2 
"quera evitar fijarme en dos colecciones al mismo tiempo pero al final lo tuve que hacer para asignar el diccionario... Pero bueno, si le paso arrays es ms cmodo para usarlo en el workspace y en los tests"
|nuevoReq|
	nuevoReq:= self new criterios: Dictionary new; personasConvocables: Set new.
	anArray do: [:elem | nuevoReq criterios at: elem put: (anArray2 at:  (anArray indexOf: elem))].
	^nuevoReq
	! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/15/2012 20:11'!
criterios
^criterios! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 13:05'!
criterios: unDiccionarioDeSymbolsyParametros
criterios:= unDiccionarioDeSymbolsyParametros ! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 10:42'!
filtra: unaColeccionDePersonas
self personasConvocables: (unaColeccionDePersonas select: [:candidato | self criterios keys allSatisfy: [:c| (c asSymbol value: candidato)= (criterios at: c).]])! !

!CriterioMultiple methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 09:21'!
initialize
self personasConvocables: Set new.! !

!CriterioMultiple methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:29'!
personasConvocables
	^ personasConvocables! !

!CriterioMultiple methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:29'!
personasConvocables: anObject
	personasConvocables := anObject! !

Object subclass: #CriterioUnico
	instanceVariableNames: 'condicion parametro personasConvocables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!CriterioUnico class methodsFor: 'instance creation' stamp: 'ClaraAllende 4/19/2012 20:55'!
nuevoConCondicion: aByteString yParametro: aByteString2 
	^self new condicion: aByteString; parametro: aByteString2; personasConvocables: Set new.! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 16:18'!
condicion
^condicion! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 08:48'!
condicion: unString
"es un String que yo despus voy a manejar como symbol"
condicion:= unString! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/19/2012 21:19'!
filtra: unaColeccionDePersonas
personasConvocables:= unaColeccionDePersonas select: [:candidato | (self condicion asSymbol value: candidato) == self parametro  ]
! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 12:54'!
parametro
^parametro
! !

!CriterioUnico methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/18/2012 12:54'!
parametro: unParametro
parametro:= unParametro
! !

!CriterioUnico methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:12'!
personasConvocables
	^ personasConvocables! !

!CriterioUnico methodsFor: 'accessing' stamp: 'ClaraAllende 4/18/2012 16:12'!
personasConvocables: anObject
	personasConvocables := anObject! !

Object subclass: #Empresa
	instanceVariableNames: 'personas notebooks salas proyectores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Empresa commentStamp: 'ClaraAllende 4/20/2012 12:04' prior: 0!
Empresa representa al objeto que conoce a todas las personas y recursos que se van a chequear para decidir si se puede realizar una reunin o no.

Instance Variables:
	personas	<ProtoObject | PseudoContext>
	notebooks	<ProtoObject | PseudoContext>
	salas	<ProtoObject | PseudoContext>
	proyectores	<ProtoObject | PseudoContext>!

!Empresa class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:02'!
nuevaConPersonas: unasPersonas proyectores: unosProyectores notebooks: unasNotebooks salas: unasSalas

^self new personas: unasPersonas; proyectores: unosProyectores; notebooks: unasNotebooks; salas: unasSalas.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
notebooks
^notebooks! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
notebooks: unaColeccionDeNotebooks
notebooks:= unaColeccionDeNotebooks ! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
personas
^personas! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:03'!
personas: unaColeccionDePersonas
personas:= unaColeccionDePersonas ! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:30'!
proyectores
^proyectores! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:30'!
proyectores: unaColeccionDeProyectores
proyectores:= unaColeccionDeProyectores! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:30'!
salas
^salas! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 11:29'!
salas: unaColeccionDeSalas
salas:= unaColeccionDeSalas! !

Object subclass: #Notebook
	uses: Horario
	instanceVariableNames: 'horariosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Notebook class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Notebook methodsFor: 'accessing' stamp: 'LucasGiudice 4/20/2012 14:59'!
horariosOcupados 
	^horariosOcupados ! !

!Notebook methodsFor: 'initialization' stamp: 'LucasGiudice 4/18/2012 10:25'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Persona
	uses: Horario + CosteablePorHora @ {#costoPara:->#costoGeneralPara:}
	instanceVariableNames: 'proyecto rol sector edificio nombre compromisos costoPorHora horariosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Persona commentStamp: 'Paul 4/17/2012 16:37' prior: 0!
Representa a una Persona que puede ser Convocante o Aisistente de una Reunion. 
Como usa trait Disponible tiene que implementar mensaje "compromisos".
Como usa trait CosteablePorHora tiene que implementar mensaje "costoPorHora".
Implementa interfaz Recurso, por eso tiene que sorbreescribir los mentodos:
- disponibleEn: unDia por: horas
- costoPara: unaReunion

Instance Variables:
	proyecto	<ProtoObject | PseudoContext>
	rol	<ProtoObject | PseudoContext>
	sector	<ProtoObject | PseudoContext>
	edificio	<ProtoObject | PseudoContext>
	nombre	<ProtoObject | PseudoContext>
	compromisos	<ProtoObject | PseudoContext>!

Persona class
	uses: CosteablePorHora classTrait + Horario classTrait
	instanceVariableNames: ''!

!Persona class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 14:55'!
nuevaAsignadaA: unProyecto conRol: unRol enUnEdificio: unEdificio sector: unSector
^self new proyecto: unProyecto; rol: unRol; edificio: unEdificio; sector: unSector.! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
compromisos
	^ compromisos! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
compromisos: anObject
	compromisos := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 17:26'!
convocarReunionConRequerimiento: unRequerimiento recursos: unosRecursos enCantidades: unasCantidades duracion: unaDuracion 
"unosRecursos y unasCantidades son arrays estticos de strings - ver el mtodo Reunion>>#reservarRecursos:  cantidad: "

|nuevaReunion|

nuevaReunion:= Reunion nuevaConRequerimiento: unRequerimiento convocadaPor: self duracion: unaDuracion  empresa: self empresa.

nuevaReunion convocarAsistentes .

"el contrato es que si no se puede realizar la reunin que se intenta convocar, lance el error ac."
nuevaReunion sePuedeRealizar ifFalse:  [self error: 'No se puede realizar la reunin']  
						   ifTrue: [ 
							nuevaReunion reservarSala;
										   reservarRecursos: unosRecursos cantidad:unasCantidades; 										 										   solicitarCateringSiHayGenteImportante;
										   costoTotal].

^nuevaReunion! !

!Persona methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:27'!
costoPara: unaReunion
	"calcula el costo para una reunion solo si el convocante es de otro proyecto"

	(unaReunion host proyecto = self proyecto)   "son Strings"
		ifTrue: [ ^ 0 ]
		ifFalse: [ ^ self costoGeneralPara: unaReunion ]! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 16:31'!
costoPorHora
	^ costoPorHora! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 16:31'!
costoPorHora: anObject
	costoPorHora := anObject! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
edificio
	^ edificio! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
edificio: unEdificio
edificio:= unEdificio! !

!Persona methodsFor: 'manejoDeHoras' stamp: 'Paul 4/20/2012 19:35'!
horariosOcupados
	horariosOcupados isNil
		ifTrue: [ horariosOcupados := Set new ].
	^ horariosOcupados! !

!Persona methodsFor: 'initialization' stamp: 'LucasGiudice 4/18/2012 10:17'!
initialize 
 horarioOcupado := Set new.! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 13:30'!
nombre
^nombre! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 13:22'!
nombre: unNombre
nombre:= unNombre! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
proyecto
	^ proyecto! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
proyecto: unProyecto
proyecto:= unProyecto! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
rol
	^ rol! !

!Persona methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:44'!
rol: unRol
rol:= unRol! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
sector
	^ sector! !

!Persona methodsFor: 'accessing' stamp: 'Paul 4/17/2012 15:55'!
sector: anObject
	sector := anObject! !

Object subclass: #Proyector
	uses: Horario
	instanceVariableNames: 'horariosOcupados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Proyector class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Proyector methodsFor: 'accessing' stamp: 'LucasGiudice 4/20/2012 15:00'!
horariosOcupados 
	^horariosOcupados ! !

!Proyector methodsFor: 'initialization' stamp: 'LucasGiudice 4/18/2012 10:25'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Requerimiento
	instanceVariableNames: 'rol proyecto sector nombre requerimientosDeTurno convocados personas reunion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

!Requerimiento commentStamp: 'ClaraAllende 4/20/2012 12:40' prior: 0!
Esta clase representa los posibles requerimientos para convocar a una persona a una reunin. Un requerimiento conoce a un CriterioUnico o un CriterioMultiple, y ellos son los encargados de filtrar las personas y recursos convocables/usables para una reunin. 
Los recursos son opcionales, de modo que si para una reunin son necesarios ciertos recursos, se va a tener que mandar el mensaje #seleccionarRecursosNecesariosDe:  cantidad:  al requerimiento correspondiente a dicha reunin (no voy a crear requeriemientos con recursos por default, porque si tuviera colecciones vacas debera chequear todo el tiempo si tienen elementos o no.)

Instance Variables:
	rol	<ProtoObject | PseudoContext>
	proyecto	<ProtoObject | PseudoContext>
	sector	<ProtoObject | PseudoContext>
	nombre	<ProtoObject | PseudoContext>!

!Requerimiento class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:38'!
nuevoConReqs: unosReqs
^self new requerimientosDeTurno: unosReqs.! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/19/2012 20:49'!
convocados
	^ convocados! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/19/2012 20:49'!
convocados: anObject
	convocados := anObject! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 10:10'!
filtrarPor: unaColeccinDeCriterios

 unaColeccinDeCriterios do:  [:criterio | criterio filtra: self personas].
! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 11:53'!
personas
	^ personas! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 11:54'!
personas: unasPersonas
	personas:= unasPersonas! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 10:03'!
posiblesAsistentes
^self requerimientosDeTurno inject: Set new into: [:accum : req | accum union: req personasConvocables]! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:47'!
posiblesAsistentesConDisponibilidadHoraria 
^self posiblesAsistentes select: [:p | p tenesDuracionDisponible: self reunion duracion]! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 20:17'!
requerimientosDeTurno 
^requerimientosDeTurno! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 20:17'!
requerimientosDeTurno: unosReqs
requerimientosDeTurno:= unosReqs.! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 11:22'!
reunion
^reunion! !

!Requerimiento methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 11:25'!
reunion: unaReunion
reunion:= unaReunion! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:40'!
seleccionarAsistentes

self filtrarPor: self requerimientosDeTurno.
(self convocados: self posiblesAsistentesConDisponibilidadHoraria) ! !

!Requerimiento methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:33'!
seleccionarRecursosNecesariosDe: unaDeLasColeccionesDeRecursos cantidad: unaCantidad
"De nuevo,voy a manejar strings convirtiendolos a symbols para saber cual coleccin de recursos tengo que filtrar. Es una manera bastante bastante fea de manejarlos, de hecho, me gustara tratarlos polimrficamente, pero bueh"

"Es para charlar si quieren pasarle ms de un recurso o mandar tres veces este mensaje. Esa segunda opcin complejizara un poco el cdigo"
|coleccionDeDisponibles|

coleccionDeDisponibles:= (self reunion empresa perform: (unaDeLasColeccionesDeRecursos asSymbol)) select:[:elem | elem tenesDuracionDisponible: self reunion duracion.].

"Devuelvo los primeros objetos designados por unaCantidad, porque me da lo mismo cualquiera. Adems #first: lanza una excepcin si no pudo encontrar la cantidad de elementos necesarios"
^coleccionDeDisponibles first: unaCantidad.! !

Object subclass: #Reunion
	instanceVariableNames: 'host asistentes recursos edificio duracion requerimiento proyecto horarioOcupado empresa recursosOcupados catering sala'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Reunion class
	instanceVariableNames: 'duracion'!

Reunion class
	instanceVariableNames: 'duracion'!

!Reunion class methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 12:42'!
nuevaConRequerimiento: unRequerimiento convocadaPor: unHost duracion:  unaDuracion empresa: unaEmpresa
^self new host: unHost; requerimiento: unRequerimiento; duracion: unaDuracion; empresa: unaEmpresa.! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:33'!
asistentes
^self requerimiento convocados.! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 16:52'!
catering
^catering! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 16:52'!
catering: elCatering
catering:= elCatering! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:32'!
convocarAsistentes
	 self requerimiento seleccionarAsistentes! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 16:46'!
costoCatering

^self catering ifNotNilDo: [self catering costoPara: self.]! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:54'!
costoRecursos 
^self recursosOcupados  inject: 0 into:  [:total :recurso | total + recurso costoPara: self.]! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:53'!
costoTotal

^self costoTotalPersonas + self costoRecursos + self costoTransporte + self costoCatering. ! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:54'!
costoTotalPersonas 

^self asistentes inject: 0 into:  [:total :asistente | total + asistente costoPara: self.]! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:58'!
costoTransporte
(self asistentes anySatisfy: [:asistente | asistente edificio ~ self sala edificio]) 
		ifTrue: [^Transporte new costoPara: self]  "reservar implica que lo tengo que conocer de antes?"
		ifFalse: [^0]! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:46'!
duracion
^duracion! !

!Reunion methodsFor: 'accessing' stamp: 'LucasGiudice 4/20/2012 12:58'!
duracion: unaDuracion
duracion:= unaDuracion 

"tiene que ser de tipo Duration "! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 12:29'!
empresa
^empresa! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 12:29'!
empresa: unaEmpresa
empresa:= unaEmpresa! !

!Reunion methodsFor: 'accessing' stamp: 'LucasGiudice 4/18/2012 10:26'!
horarioOcupado 
	^horarioOcupado ! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:44'!
host
^host! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 10:52'!
host: elHost
host:= elHost! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 12:52'!
initialize 
      self requerimiento reunion: self.
	self recursosOcupados: Set new.
	horarioOcupado := Set new.
	
	! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 11:27'!
personas
^self empresa personas! !

!Reunion methodsFor: 'printing' stamp: 'ClaraAllende 4/20/2012 17:12'!
printOn: aStream
 "En vez de mostrarse como 'a Reunion' se va a mostrar como: 
	'nueva Reunion horario: costo:proyecto:'"
	
|title|

	title:= self className.

	aStream nextPutAll: 'nueva '; 
			 nextPutAll: title; 
			 nextPutAll: ' horario: '; 
			 nextPutAll: self horarioOcupado; 
			 nextPutAll: ' costo: ';
			 nextPutAll: self costoTotal;
			 nextPutAll: ' proyecto';
			 nextPutAll: self host proyecto.  
! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/13/2012 13:37'!
proyecto
^self host proyecto.! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 12:51'!
recursosOcupados
^recursosOcupados ! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 12:51'!
recursosOcupados: unosRecursos
recursosOcupados:= unosRecursos ! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/15/2012 18:44'!
requerimiento
^requerimiento! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/12/2012 12:55'!
requerimiento: unRequerimiento
requerimiento:= unRequerimiento! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 17:21'!
reservarRecurso: unRecurso cantidad: unaCantidad
"con la salvedad de que unRecurso es en realidad en plural, i.e, si necesito un proyector, en el parmetro unRecurso debera pasarse el string 'proyectores'. Est acoplado con como manejo los strings para convertirlos en symbols para filtrar las distintas colecciones, pero no se me ocurri una manera menos fea de hacerlo :("

|recursoReservado|

recursoReservado:= self requerimiento seleccionarRecursosNecesariosDe: unRecurso cantidad: unaCantidad.

self recursosOcupados inject: recursoReservado into: [:accum :r | accum union: r].! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 17:22'!
reservarRecursos: unosRecursos cantidad: unasCantidades
"Este vale para varios recursos al mismo tiempo.
NOTA: No se debe usar este mtodo para las salas!!!!!! Como siempre se elige una, hay que usar el el accessor al atributo directamente."
unosRecursos do:[ :recurso | self reservarRecurso: recurso cantidad: (unasCantidades at: (unosRecursos indexOf: recurso))].! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 17:26'!
reservarSala

self sala: self empresa salas anyOne.
self recursosOcupados add: self sala.! !

!Reunion methodsFor: 'accessing' stamp: 'ClaraAllende 4/20/2012 17:23'!
sala: unaSala
sala:= unaSala! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 17:24'!
sePuedeRealizar

^self asistentes notEmpty 
				! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 16:52'!
solicitarCateringSiHayGenteImportante

(self asistentes anySatisfy: [:asistente | (asistente rol: 'project leader') or: [asistente rol: 'gerente' ]]) ifTrue:[ self catering: Catering new.]! !

Object subclass: #Sala
	uses: Horario
	instanceVariableNames: 'horariosOcupados edificio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Sala class
	uses: Horario classTrait
	instanceVariableNames: ''!

!Sala methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:18'!
edificio
 ^edificio! !

!Sala methodsFor: 'as yet unclassified' stamp: 'ClaraAllende 4/20/2012 15:18'!
edificio: unEdificio
edificio:= unEdificio! !

!Sala methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/20/2012 15:01'!
horariosOcupados 
	^horariosOcupados! !

!Sala methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/18/2012 10:27'!
initialize 
	horarioOcupado := Set new.! !

Object subclass: #Transporte
	uses: Horario + CosteablePorHora
	instanceVariableNames: 'horariosOcupados costo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP'!

Transporte class
	uses: Horario classTrait + CosteablePorHora classTrait
	instanceVariableNames: ''!

!Transporte methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/18/2012 12:09'!
costoPorHora 
	^costo! !

!Transporte methodsFor: 'requiredMethods' stamp: 'LucasGiudice 4/20/2012 15:02'!
horariosOcupados 
	^horariosOcupados ! !

!Transporte methodsFor: 'initialization' stamp: 'LucasGiudice 4/18/2012 10:27'!
initialize 
	horarioOcupado := Set new.! !
